// Generated by CoffeeScript 2.6.1
(function() {
  var _compose, compose, flatten, isEmpty, isFunction,
    splice = [].splice;

  ({flatten, isFunction, isEmpty} = require("../helpers"));

  _compose = function(funcs) {
    var fn;
    if (isEmpty(funcs)) {
      return function(...args) {
        var cb, ref;
        ref = args, [...args] = ref, [cb] = splice.call(args, -1);
        if (!isFunction(cb)) {
          args = [...args, cb];
          cb = function() {};
        }
        return cb(null, ...args);
      };
    } else {
      [fn, ...funcs] = funcs;
      return function(...args) {
        var cb, ref;
        ref = args, [...args] = ref, [cb] = splice.call(args, -1);
        if (!isFunction(cb)) {
          args = [...args, cb];
          cb = function() {};
        }
        return fn(...args, function(err, ...data) {
          if (err) {
            return cb(err, ...data);
          }
          return _compose(funcs)(...data, cb);
        });
      };
    }
  };

  compose = function(...funcs) {
    return _compose(flatten(funcs));
  };

  compose.doc = `# \`compose(asyncFn1, asyncFn2, ...)\` composes the asynchronous functions
# \`asyncFn1\`, \`asyncFn2\`, ... from left-to-right, e.g.,
# \`compose(f1, f2, f3)(x, cb)\` corresponds to something like:
#   f1(x, function(e, x) {
#           if (e) { return cb(e); }
#           f2(x, function(e, x) {
#                   if (e) { return cb(e); }
#                   f3(x, cb) }) })`;

  module.exports = compose;

}).call(this);
