// Generated by CoffeeScript 2.6.1
(function() {
  var _concurrent, concurrent, flatten, isArray;

  ({flatten, isArray} = require("../helpers"));

  _concurrent = function(funcs) {
    if (funcs.length === 0) {
      return function(cb) {
        return cb("EMPTY-UNION", null);
      };
    }
    return function(args, cb = function() {}) {
      var counter, errors, i, j, ref, result;
      if (!isArray(args)) {
        args = (function() {
          var j, ref, results;
          results = [];
          for (i = j = 1, ref = funcs.length; (1 <= ref ? j <= ref : j >= ref); i = 1 <= ref ? ++j : --j) {
            results.push(args);
          }
          return results;
        })();
      }
      if (args.length !== funcs.length) {
        throw new Error("Number of actual parameters doesn't match!!!");
      }
      counter = funcs.length;
      result = null;
      errors = [];
      for (i = j = 0, ref = counter - 1; (0 <= ref ? j <= ref : j >= ref); i = 0 <= ref ? ++j : --j) {
        (function(i) {
          if (result == null) {
            return funcs[i](args[i], function(err, data) {
              if (result != null) {
                return;
              }
              counter--;
              if (err) {
                errors[i] = err;
                if (counter === 0) {
                  return cb(errors, null);
                }
              } else {
                result = data;
                return cb(null, data);
              }
            });
          }
        })(i);
      }
    };
  };

  concurrent = function(...funcs) {
    return _concurrent(flatten(funcs));
  };

  concurrent.doc = `# \`concurrent(aFn1, aFn2, ..., aFnk)\` generates a new async function
# which takes an array of k elements and a callback \`cb\` as arguments,
# runs the functions cuncurrently with the elements of the array,
# respectively.
# The first function which succeeds, (err = null), calls \`cb\`
# with its results.`;

  module.exports = concurrent;

}).call(this);
