// Generated by CoffeeScript 2.6.1
(function() {
  var _merge, flatten, isArray, isEmpty, isFunction, iterFn, merge;

  ({isArray, isFunction, isEmpty, flatten} = require("../helpers"));

  iterFn = function(funcs, args, errors, cb) {
    var a, fn;
    if (isEmpty(funcs)) {
      return cb(errors);
    }
    [fn, ...funcs] = funcs;
    [a, ...args] = args;
    if (!isFunction(fn)) {
      errors.push(Error("Argument to 'merge' is not a function!"));
      setImmediate(iterFn, funcs, args, errors, cb);
    } else {
      fn(a, function(err, res) {
        if (err) {
          errors.push(err);
          return setImmediate(iterFn, funcs, args, errors, cb);
        } else {
          return cb(null, res);
        }
      });
    }
  };

  _merge = function(funcs) {
    if (isEmpty(funcs)) {
      throw Error("EMPTY-MERGE");
    }
    return function(args, cb) {
      var i;
      if (!isArray(args)) {
        args = (function() {
          var j, ref, results;
          results = [];
          for (i = j = 1, ref = funcs.length; (1 <= ref ? j <= ref : j >= ref); i = 1 <= ref ? ++j : --j) {
            results.push(args);
          }
          return results;
        })();
      }
      if (args.length !== funcs.length) {
        return cb(Error(`merge(...) needs ${funcs.length} arguments but got ${args.length}!`));
      }
      return iterFn(funcs, args, [], cb);
    };
  };

  merge = function(...funcs) {
    return _merge(flatten(funcs));
  };

  merge.doc = `# \`merge(afn1, afn2, ...)\` transforms \`afn1, afn2, ...\` into a new
# async function which takes two arguments, \`[a1, a2, ...], cb\`. 
# It tries to  execute \`afn1(a1,cb)\` and if error occurs, it tries
# \`afn2(a2, cb)\`, and so on, till one of the calls does not generate
# an error.`;

  module.exports = merge;

}).call(this);
