// Generated by CoffeeScript 2.6.1
(function() {
  var isEmpty, reduce;

  ({isEmpty} = require("../helpers"));

  reduce = function(afunc) {
    return function(args, cb = function() {}) {
      if (isEmpty(args)) {
        return cb(new Error("An non-empty array is required!"));
      }
      if (args.length === 1) {
        return cb(null, args[0]);
      }
      (function([x, y, ...args]) {
        return afunc(x, y, function(err, xy) {
          if (err != null) {
            return cb(err);
          }
          return reduce(afunc)([xy, ...args], cb);
        });
      })(args);
    };
  };

  reduce.doc = `# \`reduce(asyncFn)\` generates a new async function 'fold-left',
# which takes a non-empty array of elements and a callback \`cb\` as
# arguments, e.g:
# > reduce(delay (x,y) -> x + y) [100,1,1], (err, x) -> console.log x
# prints '102'`;

  module.exports = reduce;

}).call(this);
