// Generated by CoffeeScript 2.6.1
(function() {
  var retry,
    splice = [].splice;

  retry = function(asyncFun, n = 2, timeout = 500) {
    var count;
    count = n;
    if (!(count >= 1)) {
      throw Error(`\`n\` must be at least 1 (one) but was: \`${n}\``);
    }
    return function(...args) {
      var cb, iterFun, orig_args, params, ref;
      ref = orig_args = args, [...params] = ref, [cb] = splice.call(params, -1);
      iterFun = function() {
        return asyncFun(...params, function(err, ...data) {
          if (count > 1 && err) {
            count--;
            return setTimeout(iterFun, timeout);
          } else {
            return cb(err, ...data);
          }
        });
      };
      return iterFun();
    };
  };

  retry.doc = `#    \`retry(asyncFun)\` transforms \`asyncFun\` into another async function
# which will try executing \`asyncFun\` twice, if an error occurs, before
# calling its \`callback\`. Actually, the signature is:
#   \`retry(asyncFun,times=2,interval=500)\`
# and it returns an async function.`;

  module.exports = retry;

}).call(this);
