// Generated by CoffeeScript 2.6.1
(function() {
  var _cancel, semaphore,
    splice = [].splice;

  _cancel = "[functors/semaphore] RESOURCE KILLED - execution cancelled!";

  semaphore = function(maxRunning = 10) {
    var alive, queue, res, running;
    queue = [];
    running = 0;
    alive = true;
    res = function(fn, context) {
      return function(...args) {
        var _that, cb, ref;
        ref = args, [...args] = ref, [cb] = splice.call(args, -1);
        _that = context != null ? context : this;
        if (alive) {
          queue.push(fn.bind(_that, ...args, function(err, ...data) {
            running--;
            if (queue.length > 0) {
              running++;
              if (alive) {
                queue.shift()();
              } else {
                queue.shift();
                cb(Error(_cancel));
              }
            }
            return cb(err, ...data);
          }));
          if (running < maxRunning) {
            running++;
            if (alive) {
              return queue.shift()();
            } else {
              queue.shift();
              return cb(Error(_cancel));
            }
          }
        } else {
          return cb(Error(_cancel));
        }
      };
    };
    res.kill = function() {
      return alive = false;
    };
    res.resurrect = function() {
      return alive = true;
    };
    return res;
  };

  semaphore.doc = `#  \`semaphore(maxRunning = 10)\` constructs a 'semaphore' which is a
#  function \`function(afn, context)\` that creates a new async
#  function which behaves as its argument \`afn\`. If there are already
#  \`maxRunning\` functions running against the semaphore, the execution
#  is delayed.`;

  module.exports = semaphore;

}).call(this);
