// Generated by CoffeeScript 2.6.1
(function() {
  var isFunction, throttle,
    slice = [].slice;

  ({isFunction} = require("../helpers"));

  throttle = function(fn, waitTime = 2000) {
    var context, lastRun, pending;
    pending = false;
    lastRun = new Date("Jan 01 1965");
    context = {
      $: null,
      args: null
    };
    return function(...args) {
      var now;
      if (!pending) {
        now = new Date();
        if (waitTime < now - lastRun) {
          lastRun = now;
          return fn.apply(this, args);
        }
        pending = true;
        context.$ = this;
        context.args = args;
        setTimeout(function() {
          fn.apply(context.$, context.args);
          lastRun = new Date();
          return pending = false;
        }, waitTime - (now - lastRun));
      } else {
        (function(err) {
          var cb, ref;
          ref = context.args, [cb] = slice.call(ref, -1);
          context.$ = this;
          context.args = args;
          if (isFunction(cb)) {
            return cb(err);
          }
          throw err;
        })(new Error("Too many calls..."));
      }
    };
  };

  throttle.doc = `#  \`throttle(fn, waitTime = 2000)\` constructs a function, which behaves
#  as its argument \`fn\`, unless it is called in intervals smaller than \`waitTime\`.
#  In that case only the last call within that \`waiting time\` will be made.`;

  module.exports = throttle;

}).call(this);
